
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//	jhrg,jimg	James Gallagher (jgallagher@gso.uri.edu)

// $Log: javascript.h,v $
// Revision 1.3  1999/05/18 20:08:18  jimg
// Fixed massive problems introduced by the String to string changes.
//

const string java_code = "

// $Id: javascript.h,v 1.3 1999/05/18 20:08:18 jimg Exp $

// Event handlers for the disposition button.

// The ascii_button handler sends data to a new window. The user can then 
// save the data to a file.

function ascii_button() {
    var url = new String(document.forms[0].url.value);

    var url_parts = url.split(\"?\");
    /* handle case where constraint is null. */
    if (url_parts[1] != null) {
        var ascii_url = url_parts[0] + \".ascii?\" + url_parts[1];
    }
    else {
        var ascii_url = url_parts[0] + \".ascii?\";
    }

    window.open(ascii_url, \"ASCII_Data\");
}

/* The binary_button handler loads the data to the current window. Since it 
   is binary, Netscape will ask the user for a filename and save the data
   to that file. */

function binary_button() {
    var url = new String(document.forms[0].url.value);

    var url_parts = url.split(\"?\");
    /* handle case where constraint is null. */
    if (url_parts[1] != null) {
        var binary_url = url_parts[0] + \".dods?\" + url_parts[1];
    }
    else {
        var binary_url = url_parts[0] + \".dods?\";
    }

    window.location = binary_url;
}

/* Route the URL to Matlab. Users must add an entry into their mime types
   file (aka list of Netscape helper applications) so that the URL will
   be fedd into Matlab which must, in addition, be running loaddods. 

   Note that reflection_cgi is a global JavaScript variable set at the 
   begining of this `file' (aka Perl string variable). */

function matlab_button() {
    var matlab_url = new String(document.forms[0].url.value);

    /* Build a call to the reflector CGI. */
    var CGI = reflection_cgi + \"?\" + \"url=\" + matlab_url + \"&disposition=matlab\";

    window.location = CGI;
}

// The dods_url object.

// Method of dods_url
// Add the projection ad selection to the displayed URL.
function update_url() {
    this.build_constraint();
    var url_text = this.url;
    // Only add the projection & selection (and ?) if there really are
    // constraints! 
    if (this.projection.length + this.selection.length > 0)
        url_text += \"?\" + this.projection + this.selection;
    document.forms[0].url.value = url_text;
}

// Method of dods_url
// Scan all the form elements and pick out the various pieces of constraint
// information. Add these to the dods_url instance.
function build_constraint() {
    var p = \"\";
    var s = \"\";
    for (var i = 0; i < this.num_dods_vars; ++i) {
        if (this.dods_vars[i].is_projected == 1) {
	    // The comma is a clause separator.
	    if (p.length > 0)
	        p += \",\";
            p += this.dods_vars[i].get_projection();
	}
	var temp_s = this.dods_vars[i].get_selection();
	if (temp_s.length > 0)
	    s += \"&\" + temp_s;    // The ampersand is a prefix to the clause.
    }

    this.projection = p;
    this.selection = s;
}

// Method of dods_url
// Add the variable to the dods_var array of dods_vars. The var_index is the
// number of *this particular* variable in the dataset, zero-based.
function add_dods_var(dods_var) {
    this.dods_vars[this.num_dods_vars] = dods_var;
    this.num_dods_vars++;
}

// CTOR for dods_url
// Create the DODS URL object.
function dods_url(base_url) {
    this.url = base_url;
    this.projection = \"\";
    this.selection = \"\";
    this.num_dods_vars = 0;
    this.dods_vars = new Array();
        
    this.build_constraint = build_constraint;
    this.add_dods_var = add_dods_var;
    this.update_url = update_url;
}

// Method of dods_var
// Add a dimension to a DODS Array object.
function add_dim(dim_size) {
    this.dims[this.num_dims] = dim_size;
    this.num_dims++;
}

// Method of dods_var
// Add the array indices to the text widgets associated with this DODS
// array object. The text widgets are names <var_name>_0, <var_name>_1, ...
// <var_name>_n for an array with size N+1.
function display_indices() {
    for (var i = 0; i < this.num_dims; ++i) {
        var end_index = this.dims[i]-1;
        var s = \"0:1:\" + end_index.toString();
	var text_widget = this.name + \"_\" + i.toString();
	document.forms[0].eval(text_widget).value = s;
    }
}

// Method of dods_var
// Use this to remove index information from a DODS array object.
function erase_indices() {
    for (var i = 0; i < this.num_dims; ++i) {
	var text_widget = this.name + \"_\" + i.toString();
	document.forms[0].eval(text_widget).value = \"\";
    }
}

// Method of  dods_var
function handle_projection_change(check_box) {
    if (check_box.checked) {
        this.is_projected = 1;
	if (this.is_array == 1)
	    this.display_indices();
    }
    else {
        this.is_projected = 0;
	if (this.is_array == 1)
	    this.erase_indices();
    }

    DODS_URL.update_url();
}


// Method of dods_var
// Get the projection sub-expression for this variable.
function get_projection() {
    var p = \"\";
    if (this.is_array == 1) {
        p = this.name;
        for (var i = 0; i < this.num_dims; ++i) {
	    var text_widget = this.name + \"_\" + i.toString();
	    p += \"[\" + document.forms[0].eval(text_widget).value + \"]\";
	}
    }
    else {
	p = this.name;
    }

    return p;
}

// Method of dods_var
// Get the selection (which is null for arrays).
function get_selection() {
    var s = \"\";
    if (this.is_array == 1) {
        return s;
    }
    else {
	var text_widget = this.name + \"_selection\";
        if (document.forms[0].eval(text_widget).value != \"\") {
            var oper_widget_name = this.name + \"_operator\";
            var oper_widget = document.forms[0].eval(oper_widget_name);
	    var operator = oper_widget.options[oper_widget.selectedIndex].value;
            // If the operator is `-' then don't prepend the variable name!
            // This provides a way for users to enter function names as
            // selection clauses. 
            if (operator == \"-\")
                s = document.forms[0].eval(text_widget).value;
            else
	        s = this.name + operator + document.forms[0].eval(text_widget).value;
        }
    }

    return s;
}    

// Create an DODS Array object.
function dods_var(name, is_array) {
    // Common members
    this.name = name;
    this.is_projected = 0;
    if (is_array > 0) {
        this.is_array = 1;
        this.num_dims = 0;        // Holds the number of dimensions
        this.dims = new Array(); // Holds the length of the dimensions

        this.add_dim = add_dim;
        this.display_indices = display_indices;
        this.erase_indices = erase_indices;
    }
    else
        this.is_array = 0;

    this.handle_projection_change = handle_projection_change;
    this.get_projection = get_projection;
    this.get_selection = get_selection;
}

// Helper functions.

function describe_index() {
   defaultStatus = \"Enter start, stride and stop for the array dimension.\";
}

function describe_selection() {
   defaultStatus = \"Enter a relational expression (e.g., <20).\";
}

function describe_operator() {
   defaultStatus = \"Choose a relational operator. Use - to enter a function name).\";
}

function describe_projection() {
   defaultStatus = \"Add this variable to the projection.\";
}

";
